
/*
 * Copyright 2011-2022 Cuberite Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#pragma once

#include "StringCompression.h"





class cByteBuffer;





class CircularBufferCompressor
{
public:

	ContiguousByteBufferView GetView() const;

	Compression::Result Compress();
	void ReadFrom(cByteBuffer & Buffer);
	void ReadFrom(cByteBuffer & Buffer, size_t Size);

private:

	Compression::Compressor m_Compressor;
	std::basic_string<std::byte> m_ContiguousIntermediate;
};





class CircularBufferExtractor
{
public:

	ContiguousByteBufferView GetView() const;

	Compression::Result Extract(size_t UncompressedSize);
	void ReadFrom(cByteBuffer & Buffer, size_t Size);

private:

	Compression::Extractor m_Extractor;
	std::basic_string<std::byte> m_ContiguousIntermediate;
};
